import 'dart:convert';
import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';
import 'package:google_applovin_unity_ads/ads/SettingsModel.dart';
import 'package:google_applovin_unity_ads/google_applovin_unity_ads.dart';
import 'package:http/http.dart' as http;

Settings? _settings;

InterstitialAd? _interstitialAd;
AppLovinInterstitialAd? _appLovininterstitialAd;
FacebookInterstitialAd? _facebookInterstitialAd;
AdManagerInterstitialAd? _adManagerInterstitialAd;

AppLifecycleReactor? _appLifecycleReactor;

RewardedAd? _rewardedAd;
AppLovinRewardedAd? _appLovinrewardedAd;
FacebookRewardedAd? _facebookrewardedAd;
int _appVersionCode = 1;
bool _isRewardShowCompleted = false;

int _interestialAdTimeInterval = 0;

Future<Settings?> fetchAdsSettings({required int appVersionCode, required String settingsUrl,  String? keyName}) async {
  final response = await http.get(Uri.parse(settingsUrl));
  if (response.statusCode == 200) {
    return convertAdsSettings(appVersionCode: appVersionCode, jsonData:response.body, keyName: keyName);
  } else {
    return null;
  }
}

Future<Settings?> convertAdsSettings({required int appVersionCode, required String jsonData,  String? keyName}) async {
  _appVersionCode = appVersionCode;
  if (keyName == null || keyName == "") {
    _settings = Settings.fromJson(jsonDecode(jsonData));
  } else {
    _settings = _Response.fromJson(jsonDecode(jsonData), keyName).response;
  }
  return _settings;
}


int getAppVersionCode() {
  return _appVersionCode;
}

Settings? getAdsSettings() {
  return _settings;
}

InterstitialAd? getInterestitialAd() {
  return _interstitialAd;
}

AppLovinInterstitialAd? getAppLovinInterestitialAd() {
  return _appLovininterstitialAd;
}


FacebookInterstitialAd? getFacebookInterestitialAd() {
  return _facebookInterstitialAd;
}

AdManagerInterstitialAd? getAdManagerInterstitialAd() {
  return _adManagerInterstitialAd;
}

AppLifecycleReactor? getAppLifecycleReactor() {
  return _appLifecycleReactor;
}

RewardedAd? getRewardedAd() {
  return _rewardedAd;
}

AppLovinRewardedAd? getAppLovinRewardedAd() {
  return _appLovinrewardedAd;
}

FacebookRewardedAd? getFacebookRewardedAd() {
  return _facebookrewardedAd;
}

int getInterestialAdTimeInterval() {
  return _interestialAdTimeInterval;
}

bool IsRewardShowCompleted() {
  return _isRewardShowCompleted;
}

void setInterestitialAd(InterstitialAd? _intraAd) {
  _interstitialAd = _intraAd;
}

void setFacebookInterestitialAd(FacebookInterstitialAd? _intraAd) {
  _facebookInterstitialAd = _intraAd;
}

void setAppLovinInterestitialAd(AppLovinInterstitialAd? _intraAd) {
  _appLovininterstitialAd = _intraAd;
}

void setAdManagerInterstitialAd(AdManagerInterstitialAd? admanagerIntraAd) {
  _adManagerInterstitialAd = admanagerIntraAd;
}

void setAppLifecycleReactor(AppLifecycleReactor? lifecycle) {
  _appLifecycleReactor = lifecycle;
}

void setRewardedAd(RewardedAd? reward) {
  _rewardedAd = reward;
}

void setAppLovinRewardedAd(AppLovinRewardedAd? reward) {
  _appLovinrewardedAd = reward;
}

void setFacebookRewardedAd(FacebookRewardedAd? reward) {
  _facebookrewardedAd = reward;
}

void setRewardShowCompleted (bool isrewardComplted) {
  _isRewardShowCompleted = isrewardComplted;
}

void setInterestialAdTimeInterval(int timeInterval) {
  _interestialAdTimeInterval = timeInterval;
}


void showProgressbarDialog(BuildContext context) {
  showDialog(
      context: context,
      barrierDismissible: false,
      builder: (BuildContext context) {
    return WillPopScope(
      onWillPop: () async {
        return false;
      },
      child: Dialog(
        child: Container(
          padding: const EdgeInsets.symmetric(vertical: 18.0, horizontal: 12.0),
          child: Row(
            mainAxisSize: MainAxisSize.min,
            children:  [
              const CircularProgressIndicator(),
              Container(padding: const EdgeInsets.only(left: 18.0), child: Text(_settings?.adSetting?.adsLoadingText ?? "Ads Loading", style: const TextStyle(fontSize: 20),)),
            ],
          ),
        ),
      ),
    );
  });
}

class _Response {
  Settings? response;

  _Response({this.response});

  _Response.fromJson(Map<String, dynamic> json, String keyName) {
    response = json[keyName] != null
        ? Settings.fromJson(
        json[keyName])
        : null;
  }
}